<script lang="ts" setup>
    import { ref } from 'vue';
    import { useCustomFetch } from '../composables/useCustomFetch';
    import { useErrorStore } from '../stores/useErrorStore';
    import { useLoadingStore } from '../stores/useLoadingStore';
    import type { Star, ApiResponse } from '../types';

    const stars = ref<Star[]>([]);
    const loaderStore = useLoadingStore();
    const errorStore = useErrorStore();

    const props = defineProps({
        fromAdmin: {type: Boolean, default: false}
    })

    const selected = ref<Star|null>(null)


    async function loadData() {
        loaderStore.showLoader();
        try {
            const { data, error } = await useCustomFetch<ApiResponse<Star[]>>('/api/stars');
            if (error.value || !data.value.success) {
                errorStore.setError(data.value.message || 'An unknown error occurred');
            } else if(data.value.data){
                stars.value = data.value.data as Star[];
                if(!props.fromAdmin){
                    selected.value = stars.value[0]
                }
            }
        } catch (error) {
            errorStore.setError(error || 'An error occurred');
        } finally {
            loaderStore.hideLoader();
        }
    }

    loadData();

    watch(() => props.fromAdmin, () => {
        if(stars.value.length > 0 && !props.fromAdmin){
            selected.value = stars.value[0]
        }
    })


    function handleSelect(star: Star){
        if(props.fromAdmin){
            return
        }
        selected.value = star
    }
</script>

<template>
  <div :class="`${!props.fromAdmin ? 'flex align-items-center justify-between w-full' : ''}`">
    <div :class="`${!props.fromAdmin ? 'w-full md:w-1/3 list-name' : ''}`">
      <div
        v-for="star in stars"
        :key="star.id"
        :class="`w-full ${!props.fromAdmin ? 'cursor-pointer' : 'flex items-center justify-between mb-4'}`"
        @click="handleSelect(star)"
      >
        <p :class="`star-name ${!props.fromAdmin ? 'bg-green-500 p-1 border-custom' : 'w-1/3'}`">
          {{ star.name }} {{ star.firstName }}
        </p>
        <slot :star="star" />
        <div
          v-if="!props.fromAdmin && selected && selected.id && selected.id === star.id"
          class="block md:hidden px-1 py-2"
        >
          <StarView :star="selected" />
        </div>
      </div>
    </div>
    <div
      v-if="!props.fromAdmin && selected && selected.id"
      class="hidden md:block px-4 w-2/3"
    >
      <StarView :star="selected" />
    </div>
  </div>
</template>
<style lang="scss" scoped>
.border-custom{
    border-bottom: 1px solid rgb(74 222 128);
}
@media (min-width: 768px){
    .list-name{
        max-height: 100%;
        overflow: hidden;
    }
}
</style>
